"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const profile = __importStar(require("./actions/profiles"));
const rule = __importStar(require("./actions/rules"));
const segment = __importStar(require("./actions/segments"));
const comparisonOperator = __importStar(require("./actions/comparisonOperators"));
function connect(connectionData) {
    const baseUrlUnomi = connectionData.urlUnomi;
    const baseUrlElasticsearch = connectionData.urlElasticsearch;
    const auth = {
        username: connectionData.auth.username,
        password: connectionData.auth.password,
        bearerToken: connectionData.auth.bearerToken
    };
    let headers = {
        "Authorization": "",
        "Content-Type": "application/json"
    };
    // no bearer token
    if (auth.bearerToken === "" || typeof auth.bearerToken === "undefined") {
        headers.Authorization = "Basic " + btoa(auth.username + ":" + auth.password);
    }
    // bearer token
    else {
        headers.Authorization = "Bearer " + auth.bearerToken;
    }
    return {
        profile: {
            get: (profileId) => profile.get(baseUrlUnomi, headers, profileId),
            allUsedProperties: () => profile.allUsedProperties(baseUrlElasticsearch, headers)
        },
        rule: {
            getAll: () => rule.getAll(baseUrlUnomi, headers),
            get: (ruleId) => rule.get(baseUrlUnomi, headers, ruleId),
            create: (params) => rule.create(baseUrlUnomi, headers, params)
        },
        segment: {
            getAll: (sortOrder, limit, offset) => segment.getAll(baseUrlUnomi, headers, sortOrder, limit, offset),
            get: (segmentId) => segment.get(baseUrlUnomi, headers, segmentId),
            create: (params) => segment.create(baseUrlUnomi, headers, params),
            update: (params) => segment.update(baseUrlUnomi, headers, params),
            delete: (segmentId) => segment.deleteSegment(baseUrlUnomi, headers, segmentId)
        },
        comparisonOperator: {
            getAll: () => comparisonOperator.getAll()
        }
    };
}
exports.connect = connect;
