import { FilteredResponse } from "../../src/types/sdkResponse";
/**
 * @function callUnomi
 * @param {string} method
 * @param {string} url
 * @param {object} body
 * @param {Record<string, string>} headers
 * @param {string} successStatus
 * @returns {FilteredResponse}
 */
export declare function callUnomi(method: string, url: string, body: object, headers: Record<string, string>, successStatus: number, errorCode?: string): FilteredResponse;
/**
 * @function callElasticsearch
 * @param {string} method
 * @param {string} url
 * @param {object} body
 * @param {string} headers
 * @param {string} successStatus
 * @returns {FilteredResponse}
 */
export declare function callElasticsearch(method: string, url: string, headers: Record<string, string>, successStatus: number): FilteredResponse;
/**
 * @function callResponse
 * @param {string} method
 * @param {string} url
 * @param {any} body
 * @param {string} successStatus
 * @returns {FilteredResponse}
 */
export declare function callResponse(method: string, url: string, body: any, successStatus: number): FilteredResponse;
