"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @function createUuid
 */
function generateUuid() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        let r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
}
exports.generateUuid = generateUuid;
/**
 * @function findAllIndicesOfCharacter
 * @param {string} value
 * @param {string} character
 */
function findAllIndicesOfCharacter(value, character) {
    let indices = new Array;
    for (let i = 0; i < value.length; i++) {
        if (value[i] === character) {
            indices.push(i);
        }
    }
    return indices;
}
exports.findAllIndicesOfCharacter = findAllIndicesOfCharacter;
/**
 * @function areArraysEqual
 * @param {Array<number>} arr1
 * @param {Array<number>} arr2
 */
function areArraysEqual(arr1, arr2) {
    // Check if the arrays are the same length
    if (arr1.length !== arr2.length)
        return false;
    // Check if all items exist and are in the same order
    for (var i = 0; i < arr1.length; i++) {
        if (arr1[i] !== arr2[i])
            return false;
    }
    // Otherwise, return true
    return true;
}
exports.areArraysEqual = areArraysEqual;
/**
 * @function areArraysEqual
 * @param {Array<any>} arr
 */
function allSameType(arr) {
    return new Set(arr.map(x => typeof x)).size <= 1;
}
exports.allSameType = allSameType;
/**
 * @function getComparisonOperators
 */
function getComparisonOperators() {
    // operators in comments don't work
    const operators = [
        "equals",
        "notEquals",
        "greaterThan",
        "greaterThanOrEqualTo",
        "lessThan",
        "lessThanOrEqualTo",
        "between",
        "exists",
        "missing",
        "contains",
        "notContains",
        "startsWith",
        "endsWith",
        // "matchesRegex",
        "in",
        "notIn",
        "all",
        // "inContains",
        "hasSomeOf",
        "hasNoneOf",
    ];
    return operators;
}
exports.getComparisonOperators = getComparisonOperators;
