import * as ProfileTypes from "./profiles.d";
import * as SegmentTypes from "./segments.d";
import { QueryParams } from "../../src/types/queryBuilder"
import { FilteredResponse, sdkResponse } from "./sdkResponse";

export interface ConnectionData {
    urlUnomi: string;
    urlElasticsearch: string;
    auth: {
        username: string;
        password: string;
        bearerToken: string;
    };
}

export interface Connection {
    profile: {
        get: (profileId: string) => FilteredResponse,
        allUsedProperties: () => FilteredResponse
    },
    segment: {
        getAll: (sortOrder: string, limit: number, offset: number) => FilteredResponse,
        get: (segmentId: string) => FilteredResponse,
        create: (params: SegmentTypes.UsedProperties) => FilteredResponse,
        update: (params: SegmentTypes.UsedProperties) => FilteredResponse,
        delete: (segmentId: string) => FilteredResponse
    },
    rule: {
        getAll: () => FilteredResponse,
        get: (ruleId: string) => FilteredResponse,
        create: (params: object) => FilteredResponse
    }
    comparisonOperator: {
        getAll: () => FilteredResponse
    }
}