import { PropertiesDefault } from "./parameterValues.d";

export interface subConditionParameterValuesProperties {
    propertyName: string;
    comparisonOperator: string;
    propertyValue?: string;
    propertyValueInteger?: number;
    propertyValueDate?: string;
    propertyValues?: Array<string>;
    propertyValuesInteger?: Array<number>;
    propertyValuesDate?: Array<string>;
}

export interface subConditionProperties {
    parameterValues: subConditionParameterValuesProperties;
    type: string;
}

export interface parameterValuesProperties {
    operator: string;
    subConditions: Array<subConditionProperties>;
}

export interface conditionProperties {
    parameterValues: parameterValuesProperties;
    type: string;
}

export interface metadataProperties {
    id: string;
    name: string;
    description: string;
    scope: string;
    tags: Array<string>;
    systemTags: Array<string>;
    enabled: boolean;
    missingPlugins: boolean;
    hidden: boolean;
    readOnly: boolean;
}

export interface SegmentProperties {
    itemId?: string;
    itemType?: string;
    version?: number;
    condition?: conditionProperties;
    metadata?: metadataProperties;
}

export interface UsedProperties {
    id: string;
    name: string;
    description: string;
    scope: string;
    tags: Array<string>;
    systemTags: Array<string>;
    operator: string;
    subConditions: Array<PropertiesDefault>;
}