/**
 * @function createUuid
 */
export function generateUuid(): string {

    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {

        let r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);

        return v.toString(16);
    });
}

/**
 * @function findAllIndicesOfCharacter
 * @param {string} value
 * @param {string} character
 */
export function findAllIndicesOfCharacter(value: string, character: string): Array<number> {
    let indices = new Array;

    for (let i = 0; i < value.length; i++) {
        if (value[i] === character) {
            indices.push(i);
        }
    }

    return indices;
}

/**
 * @function areArraysEqual
 * @param {Array<number>} arr1
 * @param {Array<number>} arr2
 */
export function areArraysEqual(arr1: Array<number>, arr2: Array<number>): boolean {

    // Check if the arrays are the same length
    if (arr1.length !== arr2.length) return false;

    // Check if all items exist and are in the same order
    for (var i = 0; i < arr1.length; i++) {
        if (arr1[i] !== arr2[i]) return false;
    }

    // Otherwise, return true
    return true;
}

/**
 * @function areArraysEqual
 * @param {Array<any>} arr
 */
export function allSameType(arr: Array<any>): any {
    return new Set(arr.map(x => typeof x)).size <= 1;
}


/**
 * @function getComparisonOperators
 */
export function getComparisonOperators(): Array<string> {

    // operators in comments don't work
    const operators = [
        "equals",
        "notEquals",
        "greaterThan",
        "greaterThanOrEqualTo",
        "lessThan",
        "lessThanOrEqualTo",
        "between",
        "exists",
        "missing",
        "contains",
        "notContains",
        "startsWith",
        "endsWith",
        // "matchesRegex",
        "in",
        "notIn",
        "all",
        // "inContains",
        "hasSomeOf",
        "hasNoneOf",
        // "isDay",
        // "isNotDay"
    ];

    return operators;
}